//MakeBoardForTwoSidedPolyominoes.c - Alain Brobecker
#include <stdio.h>  //file functions, etc...
#include <stdlib.h> //exit(), malloc()
#include <string.h>
#define FALSE           0
#define TRUE            1

//variables for 2D object conversions
FILE *filep;
unsigned char *InFile;
int InFileLength;

#include "Read2DObjectLib.c"
//  #define Object2DMaxWidth 49
//  #define Object2DMaxHeight 49
//  char Object2D[Object2DMaxSize];
//  int Object2DWidth,Object2DHeight;
//  int NamedIntegerValue;
//  double NamedFloatValue;
//int ReadInteger(char *s) : stops when non digit is encountered
//double ReadFloat(char *s): stops when non digit is encountered
//int ReadNextObject2D(unsigned char *In,int InLength,int InPos,char *Out) {
//  Returns width in Object2DWidth, height in Object2DHeight, and 2D object in Object2D[]
//  Also returns the position after end2d line or -1 if no board was found
//int ReadNamedInteger(unsigned char *Name,int NameLength,unsigned char *In,int InLength,int InPos) {
//  Returns integer value in NamedIntegerValue
//  Also returns the position after "Name=" or -1 if this was not found
//int ReadNamedFloat(unsigned char *Name,int NameLength,unsigned char *In,int InLength,int InPos) {
//  Returns double value in NamedFloatValue
//  Also returns the position after "Name=" or -1 if this was not found
//int SearchNext(unsigned char *String,int StringLength,
//               unsigned char *Text,int TextLength,int TextPos) {

  //**** PrintDouble ****
//https://stackoverflow.com/questions/277772/avoid-trailing-zeroes-in-printf
//adapted from paxdiablo (removed truncating)
//!!!#include <string.h>
char StringForDouble[50];
char *PointerInString;
void PrintDouble(double number) {
  sprintf(StringForDouble,"%.10f",number); // convert number to string
  PointerInString=strchr(&StringForDouble[0],'.'); // find decimal point, if any
  if(PointerInString!=NULL) {
    PointerInString=strchr(&PointerInString[0],'\0'); // find end of string
    do{
      PointerInString--;
    } while(PointerInString[0]=='0'); // remove trailing zeros
    if (PointerInString[0]=='.') { // if all decimals were zeros, remove "."
      PointerInString[0]='\0';
    } else {
      PointerInString[1]='\0'; //otherwise put EOS after the first non zero char
    }
  }
  printf("%s",&StringForDouble[0]);
}

//**************
//****      ****
//**** MAIN ****
//****      ****
//**************
int main(int argc,char *argv[]) {
  int x,y;
  double HG,SIZE,EDGE,IBH,TBH;
  double BOARDX,BOARDY,BOARDFLOOR;

  //Read from command line
  if(argc!=2) { printf("Usage: %s Sizes.txt\n",argv[0]); exit(1); }

  //**** Load Sizes.txt ****
  filep=fopen(argv[1],"rb");
  if(filep==0) { printf("error: %s not found\n",argv[1]); exit(1); }
  fseek(filep,0,2); // 2 for EOF
  InFileLength=(int) ftell(filep);
  fseek(filep,0,0); // 0 for SOF
  InFile=(unsigned char *) malloc((unsigned int) InFileLength);
  fread(InFile,1,InFileLength,filep);
  fclose(filep);

  if(ReadNamedFloat("HG",sizeof("HG")-1,InFile,InFileLength,0)==-1) { printf("error: you must define HG\n"); exit(1); }
  HG=NamedFloatValue;
  if(ReadNamedFloat("SIZE",sizeof("SIZE")-1,InFile,InFileLength,0)==-1) { printf("error: you must define SIZE\n"); exit(1); }
  SIZE=NamedFloatValue;
  if(ReadNamedFloat("EDGE",sizeof("EDGE")-1,InFile,InFileLength,0)==-1) { printf("error: you must define EDGE\n"); exit(1); }
  EDGE=NamedFloatValue;
  if(ReadNamedFloat("IBH",sizeof("IBH")-1,InFile,InFileLength,0)==-1) { printf("error: you must define IBH (InBetweenHeight)\n"); exit(1); }
  IBH=NamedFloatValue;
  if(ReadNamedFloat("TBH",sizeof("TBH")-1,InFile,InFileLength,0)==-1) { printf("error: you must define TBH (TopAndBottomHeight)\n"); exit(1); }
  TBH=NamedFloatValue;
  if(ReadNamedFloat("BOARDX",sizeof("BOARDX")-1,InFile,InFileLength,0)==-1) { printf("error: you must define BOARDX\n"); exit(1); }
  BOARDX=NamedFloatValue;
  if(ReadNamedFloat("BOARDY",sizeof("BOARDY")-1,InFile,InFileLength,0)==-1) { printf("error: you must define BOARDY\n"); exit(1); }
  BOARDY=NamedFloatValue;
  if(ReadNamedFloat("BOARDFLOOR",sizeof("BOARDFLOOR")-1,InFile,InFileLength,0)==-1) { printf("error: you must define BOARDFLOOR\n"); exit(1); }
  BOARDFLOOR=NamedFloatValue;

  free(InFile);


  //**** Output board definition
  printf("HG="); PrintDouble(HG); printf("; //HalfGap\n");
  printf("SIZE="); PrintDouble(SIZE); printf(";\n");
  printf("EDGE="); PrintDouble(EDGE); printf(";\n");
  printf("IBH="); PrintDouble(IBH); printf("; //InBetweenHeight\n");
  printf("TBH="); PrintDouble(TBH); printf("; //TopAndBottomHeight\n");
  printf("BOARDX="); PrintDouble(BOARDX); printf(";\n");
  printf("BOARDY="); PrintDouble(BOARDY); printf(";\n");
  printf("BOARDFLOOR="); PrintDouble(BOARDFLOOR); printf(";\n");
  printf("module YGuide() {polyhedron(points=[[-EDGE+HG,-EDGE+HG,0],[0,0,TBH-HG],[EDGE-HG,-EDGE+HG,0],[-EDGE+HG,BOARDY*SIZE+EDGE-HG,0],[0,BOARDY*SIZE,TBH-HG],[EDGE-HG,BOARDY*SIZE+EDGE-HG,0]],faces=[[0,1,2],[3,5,4],[2,5,3,0],[0,3,4,1],[1,4,5,2]]);}\n");
  printf("module XGuide() {polyhedron(points=[[-EDGE+HG,-EDGE+HG,0],[0,0,TBH-HG],[-EDGE+HG,EDGE-HG,0],[BOARDX*SIZE+EDGE-HG,-EDGE+HG,0],[BOARDX*SIZE,0,TBH-HG],[BOARDX*SIZE+EDGE-HG,EDGE-HG,0]],faces=[[0,1,2],[3,5,4],[2,5,3,0],[0,3,4,1],[1,4,5,2]]);}\n");

  //****
  //!!!BUG -> printf("polyhedron(points=[[-EDGE+HG,-EDGE+HG,0],[BOARDX*SIZE+EDGE-HG,-EDGE+HG,0],[BOARDX*SIZE+EDGE-HG,BOARDY*SIZE+EDGE-HG,0],[-EDGE+HG,BOARDY*SIZE+EDGE-HG,0],[-EDGE+HG,-EDGE+HG,-BOARDFLOOR],[BOARDX*SIZE+EDGE-HG,-EDGE+HG,-BOARDFLOOR],[BOARDX*SIZE+EDGE-HG,BOARDY*SIZE+EDGE-HG,-BOARDFLOOR],[-EDGE+HG,BOARDY*SIZE+EDGE-HG,-BOARDFLOOR]],faces=[[0,1,2,3],[4,5,6,7],[0,4,5,1],[1,5,6,2],[2,6,7,3],[3,7,4,0]]);\n");
  printf("union(){\n");
  printf(" translate([-EDGE+HG,-EDGE+HG,-BOARDFLOOR]) cube([BOARDX*SIZE+2*EDGE-2*HG,BOARDY*SIZE+2*EDGE-2*HG,BOARDFLOOR]);\n");
  for(x=0;x<=BOARDX;x++) {
    printf(" translate([%d*SIZE,0,0]) YGuide();\n",x);
  }
  for(y=0;y<=BOARDY;y++) {
    printf(" translate([0,%d*SIZE,0]) XGuide();\n",y);
  }
  printf("}\n");
  exit(0);
}
