//MakeTwoSidedPolyominoWithGrooves.c - Alain Brobecker
#include <stdio.h>  //file functions, etc...
#include <stdlib.h> //exit(), malloc()
#include <string.h>
#define FALSE           0
#define TRUE            1

//variables for 2D object conversions
FILE *filep;
unsigned char *InFile;
int InFileLength;

#include "Read2DObjectLib.c"
//  #define Object2DMaxWidth 49
//  #define Object2DMaxHeight 49
//  char Object2D[Object2DMaxSize];
//  int Object2DWidth,Object2DHeight;
//  int NamedIntegerValue;
//  double NamedFloatValue;
//int ReadInteger(char *s) : stops when non digit is encountered
//double ReadFloat(char *s): stops when non digit is encountered
//int ReadNextObject2D(unsigned char *In,int InLength,int InPos,char *Out) {
//  Returns width in Object2DWidth, height in Object2DHeight, and 2D object in Object2D[]
//  Also returns the position after end2d line or -1 if no board was found
//int ReadNamedInteger(unsigned char *Name,int NameLength,unsigned char *In,int InLength,int InPos) {
//  Returns integer value in NamedIntegerValue
//  Also returns the position after "Name=" or -1 if this was not found
//int ReadNamedFloat(unsigned char *Name,int NameLength,unsigned char *In,int InLength,int InPos) {
//  Returns double value in NamedFloatValue
//  Also returns the position after "Name=" or -1 if this was not found
//int SearchNext(unsigned char *String,int StringLength,
//               unsigned char *Text,int TextLength,int TextPos) {

  //**** PrintDouble ****
//https://stackoverflow.com/questions/277772/avoid-trailing-zeroes-in-printf
//adapted from paxdiablo (removed truncating)
//!!!#include <string.h>
char StringForDouble[50];
char *PointerInString;
void PrintDouble(double number) {
  sprintf(StringForDouble,"%.10f",number); // convert number to string
  PointerInString=strchr(&StringForDouble[0],'.'); // find decimal point, if any
  if(PointerInString!=NULL) {
    PointerInString=strchr(&PointerInString[0],'\0'); // find end of string
    do{
      PointerInString--;
    } while(PointerInString[0]=='0'); // remove trailing zeros
    if (PointerInString[0]=='.') { // if all decimals were zeros, remove "."
      PointerInString[0]='\0';
    } else {
      PointerInString[1]='\0'; //otherwise put EOS after the first non zero char
    }
  }
  printf("%s",&StringForDouble[0]);
}

//**************
//****      ****
//**** MAIN ****
//****      ****
//**************
int main(int argc,char *argv[]) {
  int FilePos,x,y;
  double HG,SIZE,EDGE,IBH,TBH;

  if(argc<3) { printf("usage: %s Sizes.txt Polyomino.txt [SmoothDiamond]\n",argv[0]); exit(1); }

  //**** Load Sizes.txt ****
  filep=fopen(argv[1],"rb");
  if(filep==0) { printf("error: %s not found\n",argv[1]); exit(1); }
  fseek(filep,0,2); // 2 for EOF
  InFileLength=(int) ftell(filep);
  fseek(filep,0,0); // 0 for SOF
  InFile=(unsigned char *) malloc((unsigned int) InFileLength);
  fread(InFile,1,InFileLength,filep);
  fclose(filep);

  FilePos=0;
  if(ReadNamedFloat("HG",sizeof("HG")-1,InFile,InFileLength,0)==-1) { printf("error: you must define HG\n"); exit(1); }
  HG=NamedFloatValue;
  if(ReadNamedFloat("SIZE",sizeof("SIZE")-1,InFile,InFileLength,0)==-1) { printf("error: you must define SIZE\n"); exit(1); }
  SIZE=NamedFloatValue;
  if(ReadNamedFloat("EDGE",sizeof("EDGE")-1,InFile,InFileLength,0)==-1) { printf("error: you must define EDGE\n"); exit(1); }
  EDGE=NamedFloatValue;
  if(ReadNamedFloat("IBH",sizeof("IBH")-1,InFile,InFileLength,0)==-1) { printf("error: you must define IBH (InBetweenHeight)\n"); exit(1); }
  IBH=NamedFloatValue;
  if(ReadNamedFloat("TBH",sizeof("TBH")-1,InFile,InFileLength,0)==-1) { printf("error: you must define TBH (TopAndBottomHeight)\n"); exit(1); }
  TBH=NamedFloatValue;
  free(InFile);

  //**** Load Polyomino.txt ****
  filep=fopen(argv[2],"rb");
  if(filep==0) { printf("error: %s not found\n",argv[1]); exit(1); }
  fseek(filep,0,2); // 2 for EOF
  InFileLength=(int) ftell(filep);
  fseek(filep,0,0); // 0 for SOF
  InFile=(unsigned char *) malloc((unsigned int) InFileLength);
  fread(InFile,1,InFileLength,filep);
  fclose(filep);
  FilePos=ReadNextObject2D(InFile,InFileLength,0,Object2D);
  if(FilePos==-1) { printf("no start2d / end2d tags in file\n"); exit(1); }

  //**** Output module definition
  if(argc>3) { printf("$fn=40;\n"); }
  printf("HG="); PrintDouble(HG); printf("; //HalfGap\n");
  printf("SIZE="); PrintDouble(SIZE); printf(";\n");
  printf("EDGE="); PrintDouble(EDGE); printf(";\n");
  printf("IBH="); PrintDouble(IBH); printf("; //InBetweenHeight\n");
  printf("TBH="); PrintDouble(TBH); printf("; //TopAndBottomHeight\n");
  printf("module Diamond() {\n");
  if(argc==3) {
    printf("polyhedron(\n");
    printf("points=[[0+EDGE+HG,SIZE-EDGE-HG,0+HG],[0+EDGE+HG,SIZE-EDGE-HG,TBH+IBH+TBH-HG],[0+HG,SIZE-EDGE-HG,0+TBH+HG],[0+HG,SIZE-EDGE-HG,TBH+IBH-HG],[0+EDGE+HG,SIZE-HG,0+TBH+HG],[0+EDGE+HG,SIZE-HG,TBH+IBH-HG],[SIZE-EDGE-HG,SIZE-EDGE-HG,0+HG],[SIZE-EDGE-HG,SIZE-EDGE-HG,TBH+IBH+TBH-HG],[SIZE-EDGE-HG,SIZE-HG,0+TBH+HG],[SIZE-EDGE-HG,SIZE-HG,TBH+IBH-HG],[SIZE-HG,SIZE-EDGE-HG,0+TBH+HG],[SIZE-HG,SIZE-EDGE-HG,TBH+IBH-HG],[SIZE-EDGE-HG,0+EDGE+HG,0+HG],[SIZE-EDGE-HG,0+EDGE+HG,TBH+IBH+TBH-HG],[SIZE-HG,0+EDGE+HG,0+TBH+HG],[SIZE-HG,0+EDGE+HG,TBH+IBH-HG],[SIZE-EDGE-HG,0+HG,0+TBH+HG],[SIZE-EDGE-HG,0+HG,TBH+IBH-HG],[0+EDGE+HG,0+EDGE+HG,0+HG],[0+EDGE+HG,0+EDGE+HG,TBH+IBH+TBH-HG],[0+EDGE+HG,0+HG,0+TBH+HG],[0+EDGE+HG,0+HG,TBH+IBH-HG],[0+HG,0+EDGE+HG,0+TBH+HG],[0+HG,0+EDGE+HG,TBH+IBH-HG]],\n");
    printf("faces=[[18,12,6,0],[1,7,13,19],[4,2,0],[1,3,5],[2,4,5,3],[10,8,6],[7,9,11],[8,10,11,9],[16,14,12],[13,15,17],[14,16,17,15],[22,20,18],[19,21,23],[20,22,23,21],[0,6,8,4],[5,9,7,1],[4,8,9,5],[6,12,14,10],[11,15,13,7],[10,14,15,11],[12,18,20,16],[17,21,19,13],[16,20,21,17],[18,0,2,22],[23,3,1,19],[22,2,3,23]]);\n");
  } else {
    printf(" union(){\n");
    printf("  translate([SIZE/2,SIZE/2,TBH-HG+IBH]) linear_extrude(height = TBH, scale = (SIZE-2*HG-2*EDGE)/(SIZE-2*HG)) { offset(EDGE) { square(SIZE-2*EDGE-2*HG, center = true); } }\n");
    printf("  translate([SIZE/2,SIZE/2,0+TBH+HG]) linear_extrude(height = IBH-2*HG, scale = 1) { offset(EDGE) { square(SIZE-2*EDGE-2*HG, center = true); } }\n");
    printf("  translate([SIZE/2,SIZE/2,0+TBH+HG]) rotate([180,0,0]) linear_extrude(height = TBH, scale = (SIZE-2*HG-2*EDGE)/(SIZE-2*HG)) { offset(EDGE) { square(SIZE-2*EDGE-2*HG, center = true); } }\n");
    printf(" }\n");
  }
  printf("}\n");

  //**** Output cells and connectors
  for(y=0;y<Object2DHeight;y++) {
    for(x=0;x<Object2DWidth;x++) {
      if(Object2D[y*Object2DWidth+x]==1) {
        printf("translate([%d*SIZE,%d*SIZE,0]) Diamond();\n",x,Object2DHeight-1-y);
      }
    }//next x
  }//next y
  //x-connections between diamonds
  for(y=0;y<Object2DHeight;y++) {
    for(x=0;x<Object2DWidth-1;x++) {
      if((Object2D[y*Object2DWidth+x]==1) && (Object2D[y*Object2DWidth+x+1]==1)) {
        printf("translate([%d*SIZE-1.5*HG,%d*SIZE+EDGE+HG,TBH+HG]) cube([3*HG,SIZE-2*EDGE-2*HG,IBH-2*HG]);\n",x+1,Object2DHeight-1-y);
      }
    }//next x
  }//next y
  //y-connections between diamonds
  for(y=0;y<Object2DHeight-1;y++) {
    for(x=0;x<Object2DWidth;x++) {
      if((Object2D[y*Object2DWidth+x]==1) && (Object2D[(y+1)*Object2DWidth+x]==1)) {
        printf("translate([%d*SIZE+EDGE+HG,%d*SIZE-1.5*HG,TBH+HG]) cube([SIZE-2*EDGE-2*HG,3*HG,IBH-2*HG]);\n",x,Object2DHeight-1-y);
      }
    }//next x
  }//next y



  exit(0);
}
